Validate a query

  • POST also GET /{index}/_validate/query
  • POST also GET /_validate/query
Auth

Validates a query without running it.

Path parameters

index union string | string[] optional

Comma-separated list of data streams, indices, and aliases to search. Supports wildcards (*). To search all data streams or indices, omit this parameter or use * or _all.

Leave it out to use /_validate/query.

Query parameters

allow_no_indices boolean · default: true

If false, the request returns an error if any wildcard expression, index alias, or _all value targets only missing or closed indices. This behavior applies even if the request targets other open indices.

all_shards boolean · default: false

If true, the validation is executed on all shards instead of one random shard per index.

analyzer string

Analyzer to use for the query string. This parameter can only be used when the q query string parameter is specified.

analyze_wildcard boolean · default: false

If true, wildcard and prefix queries are analyzed.

default_operator enum · default: or

The default operator for query string query: and or or.

Values: and AND or OR
df string

Field to use as default where no field prefix is given in the query string. This parameter can only be used when the q query string parameter is specified.

expand_wildcards union oneOf · default: open

Type of index that wildcard patterns can match. If the request can target data streams, this argument determines whether wildcard expressions match hidden data streams. Supports comma-separated values, such as open,hidden.

Supported values include:

  • all: Match any data stream or index, including hidden ones.
  • open: Match open, non-hidden indices. Also matches any non-hidden data stream.
  • closed: Match closed, non-hidden indices. Also matches any non-hidden data stream. Data streams cannot be closed.
  • hidden: Match hidden data streams and hidden indices. Must be combined with open, closed, or both.
  • none: Wildcard expressions are not accepted.
Values: all open closed hidden none
explain boolean · default: false

If true, the response returns detailed information if an error has occurred.

ignore_unavailable boolean · default: false

If false, the request returns an error if it targets a missing or closed index.

lenient boolean · default: false

If true, format-based query failures (such as providing text to a numeric field) in the query string will be ignored.

rewrite boolean · default: false

If true, returns a more detailed explanation showing the actual Lucene query that will be executed.

q string

Query in the Lucene query string syntax.

Request body

query {} Query

Query in the Lucene query string syntax.

Response

application/json
explanations object[]
error string
explanation string
index string
shard number
valid boolean required
_shards object
failed number required

The number of shards the operation or search attempted to run on but failed.

successful number required

The number of shards the operation or search succeeded on.

total number required

The number of shards the operation or search will run on overall.

failures object[]
index string
node string
reason object required
type string required

The type of error

reason union string nullable

A human-readable explanation of the error, in English.

One of: string
stack_trace string

The server stack trace. Present only if the error_trace=true parameter was sent with the request.

caused_by object
Same fields as reason in failures
root_cause object[]
Same fields as reason in failures
suppressed object[]
Same fields as reason in failures
shard number
status string
primary boolean
skipped number
valid boolean required
error string